function getUniqueValues(count, min, max) {
    const values = [];
    while (values.length < count) {
        const randomValue = Math.floor(Math.random() * (max - values.length - min)) + min;
        values.push(values.slice().sort((a, b) => a - b).reduce((newValue, oldValue) => ((newValue >= oldValue) ? (newValue + 1) : newValue), randomValue));
    }
    return values;
}

function generateQuestion(winkel) {
    const frage = {
        "html": "Welcher Winkel aus <code>[0°; 360°[</code> hat denselben Sinuswert und denselben Kosinuswert wie <code>-" + (360 - winkel) + "</code>?",
        "keepOrder": true,
        "singlechoice": true,
        "choices": [
            { "html": "Winkel ", "unit": "°", "type": "number", size: 3, min: 0, max: 359, step: 1, correct: true, accept: winkel },
            { "html": "Es gibt keinen solchen Winkel" }
        ]
    }
    return frage;
}

window.MultipleChoiceTestData = {
    // Optional: Wie viele Versuche hat der/die Lernende (Standardwert: Unendlich)
    "maxTries": Infinity,

    // Optional: Soll statt der Anzahl an nötigen Versuchen bewertet werden, wie gut der/die Lernende abschneidet?
    "reportScore": false,

    // Optional: Sollen die Fragen nicht durchgemischt werden?
    "keepOrder": false,

    // Optional: Wie soll bewertet werden?
    // "questions"  → Standardwert, Frage kann entweder richtig sein (1 von 1 Punkt) oder falsch (0 von 1 Punkt)
    // "average"    → Durchschnittlicher Prozentsatz an richtig ausgewählten bzw. richtig nicht ausgewählten Antwortmöglichkeiten pro auswählbaren Antwortmöglichkeiten bei jeder Frage
    // "choices"    → Anteil der richtig ausgewählten Antwortmöglichkeiten pro auswählbaren Antwortmöglichkeiten
    "countMode": "questions",

    // Wie viele Fragen sollen für einen Test gezogen werden?
    "questionsPerTest": 5,

    // Welcher Anteil muss mindestens richtig sein, um zu bestehen?
    "threshold": 1,

    // Optional: Begrüßungstext
    "htmlIntro": "<p>Trage alle gesuchten Winkel ein:</p>",

    // Verfügbare Fragen
    "questions": [
    ],

    // Fragengeneratoren
    "generators": [
        arrFragen => getUniqueValues(5, 0, 359).forEach(winkel => arrFragen.push(generateQuestion(winkel)))
    ]
}
